import java.io.*;
import java.net.*;
import java.util.*;
import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.Dimension;
import java.awt.event.*;
import javax.swing.*;
class Syslog extends JInternalFrame implements Runnable
{
Thread Hilo=null;
BuscarNodos buscarnodos=null;
String Leer=null;
JTextArea JTtexto=null;
JTextField JTFiltro=null;
JCheckBox JCFiltro=null;
DatagramSocket s=null;
	public Syslog()
	{
	setTitle("Servidor de Syslog");
	buscarnodos=new BuscarNodos();
	JPanel JPPrincipal=new JPanel(new FlowLayout(FlowLayout.CENTER));
	JPanel JPActivacionSyslog=new JPanel(new BorderLayout(5,5));
	JPanel JPAgruparOpcionesSyslog=new JPanel(new FlowLayout(FlowLayout.CENTER));

	final JToggleButton JTBIniciarSyslog=new JToggleButton("Syslog Inactivo");
	JTBIniciarSyslog.setPreferredSize(new Dimension(120,24));
	JTBIniciarSyslog.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e)
		{
			if(JTBIniciarSyslog.isSelected())
			{
			start();
			JTBIniciarSyslog.setText("Syslog Activo");
			}
			else
			{
			stop();
			JTBIniciarSyslog.setText("Syslog Inactivo");
			}
		}
	});
	final JButton JBLimpiarSyslog=new JButton("Limpiar Syslog en lnea");
	JBLimpiarSyslog.setPreferredSize(new Dimension(180,24));
	JBLimpiarSyslog.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e)
		{
		JTtexto.setText("");
		}
	});
	JLabel JLFiltro=new JLabel("Filtro:",2);
	JTFiltro=new JTextField("",12);
	JTtexto=new JTextArea("",19,10);
	JCFiltro=new JCheckBox("Aplicar");
	JScrollPane JStexto=new JScrollPane(JTtexto);
	JStexto.setPreferredSize(new Dimension(550,500));
	JPAgruparOpcionesSyslog.add(JTBIniciarSyslog);
	JPAgruparOpcionesSyslog.add(JBLimpiarSyslog);
	JPAgruparOpcionesSyslog.add(JLFiltro);
	JPAgruparOpcionesSyslog.add(JTFiltro);
	JPAgruparOpcionesSyslog.add(JCFiltro);

	JPActivacionSyslog.add("Center",JStexto);
	JPPrincipal.add("Center",JPActivacionSyslog);
	getContentPane().add("North",JPAgruparOpcionesSyslog);
	getContentPane().add("Center",JPPrincipal);
	}
	public void start()
	{
		if(Hilo==null)
		{
		Hilo=new Thread(this);
		}
	Hilo.start();
	}
	public void stop()
	{
		if(Hilo!=null)
		{
		Hilo.stop();
		s.close();
		Hilo=null;
		}
	}

	public void run()
	{
	Ejecutar();
	}
	public void Ejecutar()
	{
		try
		{
		s=new DatagramSocket(514);
		Leer="";
			while(true)
			{
			byte[] prueba=new byte[256];
			DatagramPacket d=new DatagramPacket(prueba,256);
			Hilo.sleep(100);
			s.receive(d);
			String Fuente=d.getAddress().toString();
			Fuente=Fuente.substring(Fuente.indexOf("/")+1,Fuente.length());
			Leer=new String(d.getData(),0);
			Leer=Leer.substring(Leer.indexOf("%")+1,Leer.indexOf((char)0));
			String Enlace=buscarnodos.TraerNodo(Fuente);
				if(!Enlace.equals(Fuente))
				{
				List DatosRed=new ArrayList();
				StringTokenizer st=new StringTokenizer(Enlace,",");
				int i=0;
					while(st.hasMoreTokens())
					{
					DatosRed.add(i,st.nextToken());
					i++;
					}
				String Alias=DatosRed.get(0).toString().substring(DatosRed.get(0).toString().indexOf("(")+1,DatosRed.get(0).toString().indexOf(")"));
				String Dispositivo=DatosRed.get(1).toString();
				File LocalizacionRed=new File("Redes/"+Alias+"/Enlaces/"+Dispositivo+"/Syslog");
				LocalizacionRed.mkdirs();
				Date FechayHoraActual=new Date();
				int Mes=Math.abs(FechayHoraActual.getMonth()+1);
				String SMes=""+Mes;if(Mes<10)SMes="0"+Mes;
				int Dia=Math.abs(FechayHoraActual.getDate());
				String SDia=""+Dia;if(Dia<10)SDia="0"+Dia;
				String SAnno=""+Math.abs(FechayHoraActual.getYear()+1900);
				String Tiempo=SMes+"-"+SDia+"-"+SAnno+"(0-0-0)";
				Thread.sleep(10);
				RandomAccessFile Salvar=new RandomAccessFile("Redes/"+Alias+"/Enlaces/"+Dispositivo+"/Syslog/"+Tiempo+".txt","rw");
				String LeerArchivo="";
				boolean existe=false;
					while((LeerArchivo=Salvar.readLine())!= null)
					{
						if(LeerArchivo.indexOf(Leer)!= -1)
						{
						existe=true;
						break;
						}
					}
					if(!existe)
					{
					Salvar.seek(Salvar.length());
					Salvar.writeBytes(Leer+"\r\n");
					}
				Salvar.close();
				String LogCompleto=FechayHoraActual+","+Alias+","+Dispositivo+","+Fuente+","+Leer;
				if(JCFiltro.isSelected()== true)
				{
					if(LogCompleto.indexOf(JTFiltro.getText().toString())!= -1)
					{
					JTtexto.append(LogCompleto+"\r\n");
					}
				}
				else
				{
				JTtexto.append(LogCompleto+"\r\n");
				}
					if(Leer.indexOf("SYS-5-CONFIG_I:")!= -1)
					{
					Telnet telnet=new Telnet(Alias,Dispositivo,Fuente,DatosRed.get(3).toString(),DatosRed.get(4).toString(),DatosRed.get(5).toString(),null,null,0);
					telnet.start();
					}
				}
			Leer="";
			}
		}
		catch(IOException e)
		{
		}
		catch(InterruptedException e)
		{
		}
	}
}