import java.io.*;
import java.net.*;
import java.util.Date;
import java.util.StringTokenizer;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
class Telnet extends Thread
{
String Red,Nombre,Ip,Usuario,Clave1,Clave2,TituloComando,SInicio;
TablaMia Tabla;
int I,NumeroReintentos;
boolean Permitir=false;
	public Telnet(String red,String nombre,String ip,String usuario,String clave1,String clave2,String titulocomando,TablaMia tabla,int i)
	{
	Red=red;
	Nombre=nombre;
	Ip=ip;
	Usuario=usuario;
	Clave1=clave1;
	Clave2=clave2;
	TituloComando=titulocomando;
	Tabla=tabla;
	I=i;
	}
	public void run()
	{
		try
		{
		Thread.sleep(1);
		Ejecutar(Red,Nombre,Ip,Usuario,Clave1,Clave2,TituloComando,Tabla,I);
		}
		catch(InterruptedException e)
		{
		}
	}
	public void Ejecutar(String Red,String Nombre,String Ip,String Usuario,String Clave1,String Clave2,String TituloComando,TablaMia tabla,int i)
	{
		try
		{
		Socket s=new Socket(Ip,23);
		DataOutputStream salida=new DataOutputStream(s.getOutputStream());
		DataInputStream entrada=new DataInputStream(s.getInputStream());
		if(tabla!= null)
		{
		tabla.setValueAt("Trabajando",i,3);
		}
		String Comando="";
		if(TituloComando!=null)
		{
		RandomAccessFile ConcatenarScript=new RandomAccessFile("Script/"+TituloComando+".txt","r");
		String Leer;
			while((Leer=ConcatenarScript.readLine())!=null)
			{
			Comando=Comando+Leer+"%";
			}
		Comando=Comando.substring(0,Comando.length()-1);
		ConcatenarScript.close();
		}
		else
		{
		TituloComando="Configuracin";
		Comando="show running-config%exit";
		}
		Date FechayHoraActual=new Date();
		int Mes=Math.abs(FechayHoraActual.getMonth()+1);
		String SMes=""+Mes;if(Mes<10)SMes="0"+Mes;
		int Dia=Math.abs(FechayHoraActual.getDate());
		String SDia=""+Dia;if(Dia<10)SDia="0"+Dia;
		String SAnno=""+Math.abs(FechayHoraActual.getYear()+1900);
		int Hora=FechayHoraActual.getHours();
		String SHora=""+Hora;if(Hora<10)SHora="0"+Hora;
		int Minuto=FechayHoraActual.getMinutes();
		String SMinuto=""+Minuto;if(Minuto<10)SMinuto="0"+Minuto;
		int Segundo=FechayHoraActual.getSeconds();
		String SSegundo=""+Segundo;if(Segundo<10)SSegundo="0"+Segundo;
		String Tiempo=SMes+"-"+SDia+"-"+SAnno+"("+SHora+"-"+SMinuto+"-"+SSegundo+")";
		String[] Meses={"January","February","March","April","May","June","July","August","September","October","November","December"};
		String TiempoReemplazo=SHora+":"+SMinuto+":"+SSegundo+" "+Dia+" "+Meses[Mes-1]+" "+SAnno;
		File LocalizacionRed=new File("Redes/"+Red+"/Enlaces");
		LocalizacionRed.mkdirs();
		File LocalizacionComando=new File("Redes/"+Red+"/Enlaces/"+Nombre+"/"+TituloComando);
		LocalizacionComando.mkdirs();
		File LocalizacionArchivo=new File("Redes/"+Red+"/Enlaces/"+Nombre+"/"+TituloComando+"/"+Tiempo+".txt");
		LocalizacionArchivo.createNewFile();
		FileOutputStream EscribirArchivo=new FileOutputStream(LocalizacionArchivo);
		DataOutputStream StreamEscribirArchivo=new DataOutputStream(EscribirArchivo);
		String Datos;
			if(!Usuario.equals(""))
			{
	 		salida.writeBytes(Usuario+"\r");
			}
		salida.writeBytes(Clave1+"\r");
		salida.writeBytes("ena\r");
		salida.writeBytes(Clave2+"\r");
		salida.writeBytes("terminal length 0"+"\r");
		salida.writeBytes("set length 0"+"\r");
		StringTokenizer FormarComando=new StringTokenizer(Comando,"%");
		int z=0;
			while(FormarComando.hasMoreTokens())
			{
			String Comandos=FormarComando.nextToken();
				if(Comandos.toLowerCase().indexOf("<t>")!= -1)
				{
				Comandos=Comandos.substring(0,Comandos.indexOf("<t>"))+" "+TiempoReemplazo;
				}
			salida.writeBytes(Comandos+"\r\n");
				if(Comandos.toLowerCase().indexOf("clear")!= -1)
				{
				salida.writeBytes("\r\n");
				salida.writeBytes("\r\n");
				}
			if(z==0){SInicio=Comandos;}
			z++;
			}
			while((Datos=entrada.readLine())!=null)
			{
			Thread.sleep(1);
				if(Datos.endsWith(SInicio)){Permitir=true;}
				if(Permitir==true)StreamEscribirArchivo.writeBytes(Datos+"\r\n");
				if((Datos.indexOf(")#")!= -1)||(Datos.startsWith("end"))||(Datos.endsWith("#"))||(Datos.endsWith("(enable)")))
				{
				salida.writeBytes("Exit"+"\r\n");
				}
			}
		if(tabla!=null)
		{
		tabla.setValueAt("Finalizado",i,3);
		}
		StreamEscribirArchivo.close();
		EscribirArchivo.close();
		salida.close();
		entrada.close();
		s.close();
		}
		catch(InterruptedException e)
		{
		}
		catch(ConnectException e)
		{
			if(NumeroReintentos>10)
			{
				if(tabla!=null)
				{
				tabla.setValueAt("No fue posible alcanzar el dispositivo",i,3);
				}
			}
			else
			{
			Telnet telnet=new Telnet(Red,Nombre,Ip,Usuario,Clave1,Clave2,TituloComando,Tabla,I);
			telnet.Veces(NumeroReintentos+1);
			telnet.run();
			}
		}
		catch(Exception e)
		{
			if(NumeroReintentos>10)
			{
			tabla.setValueAt("No fue posible alcanzar el dispositivo",i,3);
			}
			else
			{
			Telnet telnet=new Telnet(Red,Nombre,Ip,Usuario,Clave1,Clave2,TituloComando,Tabla,I);
			telnet.Veces(NumeroReintentos+1);
			telnet.run();
			}

		}
	}
	public void Veces(int numeroreintentos)
	{
	NumeroReintentos=numeroreintentos;
	}
}