import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.beans.PropertyVetoException;
import java.util.Vector;
import java.util.StringTokenizer;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import javax.swing.tree.*;
class Ventana extends JFrame
{
ConfiguracionClavesGenericas configuracionclavesgenericas=null;
ConfiguracionRedes configuracionredes=null;
EjecucionScript ejecucionscript=null;
CreacionScript creacionscript=null;
DatosAlmacenados datosalmacenados=null;
Modular modular=null;
Claves claves=null;
Scanner scanner=null;
Syslog syslog=null;
ConfiguracionUsuario configuracionusuario=null;
ConfiguracionUsuarioRemoto configuracionusuarioremoto=null;
JDesktopPane Escritorio=null;
	public Ventana(String titulo)
	{
	super(titulo);

		Escritorio=new JDesktopPane();

		getContentPane().add("Center",Escritorio);
	
		final JMenuBar JMBarraPrincipal=new JMenuBar();
		JMenu JMVer=new JMenu("Datos almacenados");
		JMenuItem JMInformacionGuardadaJMVer=new JMenuItem("Informacin almacenada");
			JMInformacionGuardadaJMVer.addActionListener(new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{
						if(datosalmacenados==null)
						{
						datosalmacenados=new DatosAlmacenados();
						datosalmacenados.setDefaultCloseOperation(1);
						datosalmacenados.setBounds(100,100,600,600);
						datosalmacenados.setClosable(true);
						Escritorio.add(datosalmacenados);
						}
					datosalmacenados.setVisible(true);
					}
				});
		JMVer.add(JMInformacionGuardadaJMVer);
		JMBarraPrincipal.add(JMVer);
		JMenu JMConfiguracion=new JMenu("Configuracin");

		/*JMenuItem JMClavesGenericasJMConfiguracion=new JMenuItem("Contraseas genericas");
			JMClavesGenericasJMConfiguracion.addActionListener(new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{
					configuracionclavesgenericas=new ConfiguracionClavesGenericas();
					Escritorio.add(configuracionclavesgenericas);
					configuracionclavesgenericas.show();
					}
				});

		JMConfiguracion.add(JMClavesGenericasJMConfiguracion);*/

		JMenuItem JMConfiguracionRedesJMConfiguracion=new JMenuItem("Redes");
				JMConfiguracionRedesJMConfiguracion.addActionListener(new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{
						if(configuracionredes==null)
						{
						configuracionredes=new ConfiguracionRedes();
						configuracionredes.setDefaultCloseOperation(1);
						configuracionredes.setBounds(100,100,600,600);
						configuracionredes.setClosable(true);
						Escritorio.add(configuracionredes);
						}
					configuracionredes.setVisible(true);
					}
				});
		JMenuItem JMConfiguracionScriptJMConfiguracion=new JMenuItem("Script");
			JMConfiguracionScriptJMConfiguracion.addActionListener(new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{
						if(creacionscript==null)
						{
						creacionscript=new CreacionScript();
						creacionscript.setDefaultCloseOperation(1);
						creacionscript.setBounds(100,100,600,540);
						creacionscript.setClosable(true);
						Escritorio.add(creacionscript);
						}
					creacionscript.setVisible(true);
					}
				});

		JMenuItem JMConfiguracionUsuarioJMConfiguracion=new JMenuItem("Usuario");
			JMConfiguracionUsuarioJMConfiguracion.addActionListener(new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{
						if(configuracionusuario==null)
						{
						configuracionusuario=new ConfiguracionUsuario();
						configuracionusuario.setDefaultCloseOperation(1);
						configuracionusuario.setBounds(100,100,600,600);
						configuracionusuario.setClosable(true);
						Escritorio.add(configuracionusuario);
						}
					configuracionusuario.setVisible(true);
					}
				});


		JMConfiguracion.add(JMConfiguracionScriptJMConfiguracion);
		JMConfiguracion.add(JMConfiguracionRedesJMConfiguracion);
		JMConfiguracion.add(JMConfiguracionUsuarioJMConfiguracion);



		JMenu JMHerramientas=new JMenu("Herramientas");
		JMenuItem JMConfiguracionesJMHerramientas=new JMenuItem("Multi-Telnet");
				JMConfiguracionesJMHerramientas.addActionListener(new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{
						if(ejecucionscript==null)
						{
						ejecucionscript=new EjecucionScript();
						ejecucionscript.setDefaultCloseOperation(1);
						ejecucionscript.setBounds(100,100,600,600);
						ejecucionscript.setClosable(true);
						Escritorio.add(ejecucionscript);
						}
					ejecucionscript.setVisible(true);
					}
				});
		JMHerramientas.add(JMConfiguracionesJMHerramientas);


		JMenuItem JMContrasenasJMHerramientas=new JMenuItem("Claves");
				JMContrasenasJMHerramientas.addActionListener(new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{
						if(claves==null)
						{
						claves=new Claves();
						claves.setDefaultCloseOperation(1);
						claves.setBounds(100,100,400,300);
						claves.setClosable(true);
						Escritorio.add(claves);
						}
					claves.setVisible(true);
					}
				});
		JMHerramientas.add(JMContrasenasJMHerramientas);
	
		JMenuItem JMSyslogJMHerramientas=new JMenuItem("Syslog");
			JMSyslogJMHerramientas.addActionListener(new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{
						if(syslog==null)
						{
						syslog=new Syslog();
						syslog.setDefaultCloseOperation(1);
						syslog.setBounds(100,100,600,600);
						syslog.setClosable(true);
						Escritorio.add(syslog);
						}
					syslog.setVisible(true);
					}
				});
		JMHerramientas.add(JMSyslogJMHerramientas);

		JMenuItem JMUsuarioDispositivoJMHerramientas=new JMenuItem("Usuarios en dispositivos");
			JMUsuarioDispositivoJMHerramientas.addActionListener(new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{
						if(configuracionusuarioremoto==null)
						{
						configuracionusuarioremoto=new ConfiguracionUsuarioRemoto();
						configuracionusuarioremoto.setDefaultCloseOperation(1);
						configuracionusuarioremoto.setBounds(100,100,600,600);
						configuracionusuarioremoto.setClosable(true);
						Escritorio.add(configuracionusuarioremoto);
						}
					configuracionusuarioremoto.setVisible(true);
					}
				});
		JMHerramientas.add(JMUsuarioDispositivoJMHerramientas);



		JMenu JMAyuda=new JMenu("Ayuda");
		JMenuItem JMAcercaJMAyuda=new JMenuItem("Creditos");
				JMAcercaJMAyuda.addActionListener(new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{
						if(modular==null)
						{
						modular=new Modular();
						modular.setDefaultCloseOperation(1);
						modular.setBounds(100,100,600,600);
						modular.setClosable(true);
						Escritorio.add(modular);
						}
					modular.setVisible(true);
					}
				});
		JMAyuda.add(JMAcercaJMAyuda);
		JMBarraPrincipal.add(JMConfiguracion);
		JMBarraPrincipal.add(JMHerramientas);
		JMBarraPrincipal.add(JMAyuda);
		setJMenuBar(JMBarraPrincipal);
		setDefaultCloseOperation(3);
		getContentPane().validate();
	}

}
