import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
import java.util.StringTokenizer;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
class ConfiguracionRedes extends JInternalFrame
{
JPanel JPPrincipalConfRed=null;
JPanel JPPrincipalConfDispositivos=null;
JList ListaConfRed=null;
DefaultTableModel tableModel0=null;
TablaMia tabla0=null;
DefaultTableModel tableModel=null;
TablaMia tabla=null;

java.util.List[] ListasConfDispositivos=new java.util.List[3];
JTextField JTNombreConfDispositivos,JTDirIPConfDispositivos,JTUsuarioConfDispositivos;
JPasswordField JTClave1ConfDispositivos,JTClave2ConfDispositivos;
JComboBox JCBoxRedConfDispositivos=null;
String RedAlias="";
	public ConfiguracionRedes()
	{
	setTitle("Configuracin de redes");
	JTabbedPane JTabConfiguracion=new JTabbedPane();
	JTabConfiguracion.setPreferredSize(new Dimension(550,450));
	ConfigurarRed();
	ConfigurarDispositivos();
	JTabConfiguracion.addTab("Redes",JPPrincipalConfRed);
	JTabConfiguracion.addTab("Dispositivos",JPPrincipalConfDispositivos);
	getContentPane().add("Center",JTabConfiguracion);
	}

	public void ConfigurarRed()
	{
	JPPrincipalConfRed=new JPanel(new BorderLayout(5,5));

	JPanel JPAgruparConfRed=new JPanel(new FlowLayout(FlowLayout.CENTER));
	JPanel JPOrdenarConfRed=new JPanel(new GridLayout(2,1,5,5));
	JPanel JPNombreConfRed=new JPanel(new FlowLayout(FlowLayout.LEFT));
	JLabel JLNombreConfRed=new JLabel("Red:");final JTextField JTNombreConfRed=new JTextField("",39);
	JLNombreConfRed.setPreferredSize(new Dimension(60,10));
	JPNombreConfRed.add(JLNombreConfRed);
	JPNombreConfRed.add(JTNombreConfRed);
	JPanel JPAliasConfRed=new JPanel(new FlowLayout(FlowLayout.LEFT));
	JLabel JLAliasConfRed=new JLabel("Alias:");final JTextField JTAliasConfRed=new JTextField("",39);
	JLAliasConfRed.setPreferredSize(new Dimension(60,10));
	JPAliasConfRed.add(JLAliasConfRed);
	JPAliasConfRed.add(JTAliasConfRed);
	JPOrdenarConfRed.add(JPNombreConfRed);
	JPOrdenarConfRed.add(JPAliasConfRed);
	JPAgruparConfRed.add(JPOrdenarConfRed);

	JPanel JPtabla0=new JPanel(new FlowLayout(FlowLayout.CENTER));
	Vector v0=new Vector();
	v0.add("Redes");
	tableModel0=new DefaultTableModel(v0,0);
	tabla0=new TablaMia(tableModel0);
	tabla0.getTableHeader().setReorderingAllowed(false);
	tabla0.setSelectionMode(0);
	tabla0.setPreferredScrollableViewportSize(new Dimension(500,380));
		tabla0.getSelectionModel().addListSelectionListener(new ListSelectionListener()
		{
			public void valueChanged(ListSelectionEvent ev)
			{
			int i=tabla0.getSelectedRow();
				if(i>=0)
				{
				String red=tabla0.getValueAt(i,0).toString().substring(0,tabla0.getValueAt(i,0).toString().indexOf("("));
				String alias=tabla0.getValueAt(i,0).toString().substring(tabla0.getValueAt(i,0).toString().indexOf("(")+1,tabla0.getValueAt(i,0).toString().length()-1);
				JTNombreConfRed.setText(red);
				JTAliasConfRed.setText(alias);
				}
			}
		});
	JScrollPane JStabla0=new JScrollPane(tabla0);
	JPtabla0.add(JStabla0);
	JPPrincipalConfRed.add("North",JPAgruparConfRed);
	JPPrincipalConfRed.add("Center",JPtabla0);

		try
		{
		File CrearDirectorio=new File("Redes");
			if(!CrearDirectorio.exists())
			{
			CrearDirectorio.mkdirs();
			}
			else
			{
				if(CrearDirectorio.isFile())
				{
				CrearDirectorio.delete();
				CrearDirectorio.mkdirs();
				}
			}
		RandomAccessFile ArchivoRedes=new RandomAccessFile("Redes/Redes.cfg","r");
		String leer;
			while((leer=ArchivoRedes.readLine())!=null)
			{
			Vector VEnlaces=new Vector();
			VEnlaces.add(leer);
			tableModel0.addRow(VEnlaces);
			}
		ArchivoRedes.close();
		}
		catch(IOException error)
		{
		System.out.println(error.toString());
		}


	JPanel JPBotoneraConfRed=new JPanel(new FlowLayout(FlowLayout.CENTER));
	final JButton JBAceptarConfRed=new JButton("Salvar");
		JBAceptarConfRed.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					if(tableModel0.getRowCount()>=0)
					{
					BorrarDispositivos();
						try
						{
						File CrearDirectorio=new File("Redes");
								if(!CrearDirectorio.exists())
								{
								CrearDirectorio.mkdirs();
								}
								else
								{
									if(CrearDirectorio.isFile())
									{
									CrearDirectorio.delete();
									CrearDirectorio.mkdirs();
									}
								}
						File BorrarRedes=new File("Redes/Redes.cfg");
								if(BorrarRedes.exists())
								{
								BorrarRedes.delete();
								}
						RandomAccessFile ArchivoRedes=new RandomAccessFile("Redes/Redes.cfg","rw");
							for(int i=0;i<tableModel0.getRowCount();i++)
							{
							String red=tableModel0.getValueAt(i,0).toString().substring(0,tableModel0.getValueAt(i,0).toString().indexOf("("));
							String alias=tableModel0.getValueAt(i,0).toString().substring(tableModel0.getValueAt(i,0).toString().indexOf("(")+1,tableModel0.getValueAt(i,0).toString().length()-1);
							ArchivoRedes.writeBytes(red+"("+alias+")\r\n");
							File CrearRed=new File("Redes/"+alias);
								if(!CrearRed.exists())
								{
								CrearRed.mkdirs();
								}
								else
								{
									if(CrearRed.isFile())
									{
									CrearRed.delete();
									CrearRed.mkdirs();
									}
								}
							}

						ArchivoRedes.close();
						}
						catch(IOException error)
						{
						System.out.println(error.toString());
						}
					ActualizarRedes();
					}



				File ListarDirectorio=new File("Redes/");
				String[] SLista=ListarDirectorio.list();
				int n=ListarDirectorio.list().length;
				File[] DirectorioRed=new File[n];
					for(int i=0;i<n;i++)
					{
					DirectorioRed[i]=new File("Redes/"+SLista[i]);
						if(DirectorioRed[i].isDirectory())
						{
						String NombreRed=DirectorioRed[i].getName();
							try
							{
							RandomAccessFile ChequearRedes=new RandomAccessFile("Redes/Redes.cfg","r");
							String Leer;
							boolean Existe=false;
				 				while((Leer=ChequearRedes.readLine())!=null)
								{
									if(Leer.endsWith("("+NombreRed+")"))
									{
									Existe=true;
									break;
									}
								}
							ChequearRedes.close();		
								if(Existe==false)
								{
								EliminarDirectorios(DirectorioRed[i]);
								DirectorioRed[i].delete();
								}
							}
							catch(IOException IOE)
							{
							}
						}
					}
				}
			});


	final JButton JBAgregarConfRed=new JButton("Agregar");
		JBAgregarConfRed.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					if((JTNombreConfRed.getText().length()>0)&&(JTAliasConfRed.getText().length()>0))
					{
					boolean existe=false;
						for(int i=0;i<tableModel0.getRowCount();i++)
						{
							if((tableModel0.getValueAt(i,0).toString().startsWith(JTNombreConfRed.getText()))||(tableModel0.getValueAt(i,0).toString().endsWith("("+JTAliasConfRed.getText()+")")))
							{
							existe=true;
							JOptionPane.showMessageDialog(null,"La red existe.", "Alerta", JOptionPane.ERROR_MESSAGE);
							break;
							}
						}

						if(existe==false)
						{
						Vector z=new Vector();
						z.add(JTNombreConfRed.getText()+"("+JTAliasConfRed.getText()+")");
						tableModel0.addRow(z);
						}
					}
				}
			});


	final JButton JBBorrarConfRed=new JButton("Borrar");
		JBBorrarConfRed.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
				JTNombreConfRed.setText("");
				JTAliasConfRed.setText("");
				}
			});
	final JButton JBEliminarConfRed=new JButton("Eliminar");
		JBEliminarConfRed.addActionListener(new ActionListener()
			{
			public void actionPerformed(ActionEvent e)
			{
			int i=tabla0.getSelectedRow();
				if(i>=0)
				{
				tabla0.clearSelection();
				tableModel0.removeRow(i);
				}
			}
		});
	JPBotoneraConfRed.add(JBAceptarConfRed);
	JPBotoneraConfRed.add(JBAgregarConfRed);
	JPBotoneraConfRed.add(JBBorrarConfRed);
	JPBotoneraConfRed.add(JBEliminarConfRed);

	JPPrincipalConfRed.add("South",JPBotoneraConfRed);
	}





	public void EliminarDirectorios(File f)
	{
		try
		{
		File ListarDirectorio=new File(f.getPath()+"/");
		
		String[] SLista=ListarDirectorio.list();
		int n=ListarDirectorio.list().length;
		File[] DirectorioRed=new File[n];
			for(int i=0;i<n;i++)
			{
			DirectorioRed[i]=new File(f.getPath()+"/"+SLista[i]);
				if(DirectorioRed[i].isFile())
				{
				DirectorioRed[i].delete();
				}
				else
				{
					while(DirectorioRed[i].exists())
					{
					Thread.sleep(10);
					EliminarDirectorios(DirectorioRed[i]);	
					}
				}
			
			}
		f.delete();
		}
		catch(InterruptedException e)
		{
		}
	}
	public void ConfigurarDispositivos()
	{
	JPPrincipalConfDispositivos=new JPanel(new BorderLayout(5,5));
	JPPrincipalConfDispositivos.setBackground(new Color(204,204,204));
	JPanel JPAgruparTodoConfDispositivos=new JPanel(new FlowLayout(FlowLayout.CENTER));
	JPanel JPOrdenarAgruparyTablaConfDispositivos=new JPanel(new GridLayout(2,1,5,5));
	JPanel JPAgruparConfDispositivos=new JPanel(new FlowLayout(FlowLayout.CENTER));
	JPanel JPOrdenarConfDispositivos=new JPanel(new GridLayout(6,1,5,5));
	int separacion1=100;
	JPanel JPRedConfDispositivos=new JPanel(new FlowLayout(FlowLayout.LEFT));
	JPRedConfDispositivos.setOpaque(true);
	JLabel JLRedConfDispositivos=new JLabel("Red:",2);
	JLRedConfDispositivos.setPreferredSize(new Dimension(separacion1,10));
	JPRedConfDispositivos.add(JLRedConfDispositivos);
	JCBoxRedConfDispositivos=new JComboBox();
	JCBoxRedConfDispositivos.setPreferredSize(new Dimension(427,20));
	ActualizarRedes();
	JPRedConfDispositivos.add(JCBoxRedConfDispositivos);
	JPanel JPNombreConfDispositivos=new JPanel(new FlowLayout(FlowLayout.LEFT));
	JLabel JLNombreConfDispositivos=new JLabel("Nombre:",2);JTNombreConfDispositivos=new JTextField("",39);
	JPNombreConfDispositivos.add(JLNombreConfDispositivos);JPNombreConfDispositivos.add(JTNombreConfDispositivos);
	JLNombreConfDispositivos.setPreferredSize(new Dimension(separacion1,10));
	JPanel JPDirIPConfDispositivos=new JPanel(new FlowLayout(FlowLayout.LEFT));
	JLabel JLDirIPConfDispositivos=new JLabel("Direccin IP:",2);JTDirIPConfDispositivos=new JTextField("",39);
	JPDirIPConfDispositivos.add(JLDirIPConfDispositivos);JPDirIPConfDispositivos.add(JTDirIPConfDispositivos);
	JLDirIPConfDispositivos.setPreferredSize(new Dimension(separacion1,10));
	JPanel JPUsuarioConfDispositivos=new JPanel(new FlowLayout(FlowLayout.LEFT));
	JLabel JLUsuarioConfDispositivos=new JLabel("Usuario:",2);JTUsuarioConfDispositivos=new JTextField("",39);
	JPUsuarioConfDispositivos.add(JLUsuarioConfDispositivos);JPUsuarioConfDispositivos.add(JTUsuarioConfDispositivos);
	JLUsuarioConfDispositivos.setPreferredSize(new Dimension(separacion1,10));
	JPanel JPClave1ConfDispositivos=new JPanel(new FlowLayout(FlowLayout.LEFT));
	JLabel JLClave1ConfDispositivos=new JLabel("Clave lectura:",2);JTClave1ConfDispositivos=new JPasswordField("",39);
	JPClave1ConfDispositivos.add(JLClave1ConfDispositivos);JPClave1ConfDispositivos.add(JTClave1ConfDispositivos);
	JLClave1ConfDispositivos.setPreferredSize(new Dimension(separacion1,10));
	JPanel JPClave2ConfDispositivos=new JPanel(new FlowLayout(FlowLayout.LEFT));
	JLabel JLClave2ConfDispositivos=new JLabel("Clave escritura:",2);JTClave2ConfDispositivos=new 	JPasswordField("",39);JTClave2ConfDispositivos.setForeground(Color.red);
	JPClave2ConfDispositivos.add(JLClave2ConfDispositivos);JPClave2ConfDispositivos.add(JTClave2ConfDispositivos);
	JLClave2ConfDispositivos.setPreferredSize(new Dimension(separacion1,10));
	JPOrdenarConfDispositivos.add(JPRedConfDispositivos);
	JPOrdenarConfDispositivos.add(JPNombreConfDispositivos);
	JPOrdenarConfDispositivos.add(JPDirIPConfDispositivos);
	JPOrdenarConfDispositivos.add(JPUsuarioConfDispositivos);
	JPOrdenarConfDispositivos.add(JPClave1ConfDispositivos);
	JPOrdenarConfDispositivos.add(JPClave2ConfDispositivos);
	JPAgruparConfDispositivos.add(JPOrdenarConfDispositivos);
	JPanel JPtabla=new JPanel(new FlowLayout(FlowLayout.CENTER));
	Vector v=new Vector();
	v.add("Red");
	v.add("Nombre");
	v.add("IP");
	tableModel = new DefaultTableModel(v,0);
	tabla=new TablaMia(tableModel);
	tabla.getTableHeader().setReorderingAllowed(false);
	tabla.setPreferredScrollableViewportSize(new Dimension(520,210));
	tabla.setSelectionMode(0);
	JScrollPane JStabla=new JScrollPane(tabla);
	JPtabla.add(JStabla);
	ListasConfDispositivos[0]=new java.util.ArrayList();
	ListasConfDispositivos[1]=new java.util.ArrayList();
	ListasConfDispositivos[2]=new java.util.ArrayList();
		tabla.getSelectionModel().addListSelectionListener(new ListSelectionListener()
		{
			public void valueChanged(ListSelectionEvent ev)
			{
			int i=tabla.getSelectedRow();
			JTNombreConfDispositivos.setText(tabla.getValueAt(tabla.getSelectedRow(),1).toString());
			JTDirIPConfDispositivos.setText(tabla.getValueAt(tabla.getSelectedRow(),2).toString());
				if(ListasConfDispositivos[0].get(i).toString().equals("%"))
				{
				JTUsuarioConfDispositivos.setText("");
				}
				else
				{
				JTUsuarioConfDispositivos.setText(ListasConfDispositivos[0].get(i).toString());
				}
			JTClave1ConfDispositivos.setText(ListasConfDispositivos[1].get(i).toString());
			JTClave2ConfDispositivos.setText(ListasConfDispositivos[2].get(i).toString());
			}
		});

	JPanel JPBotoneraConfDispositivos=new JPanel(new FlowLayout(FlowLayout.CENTER));
	final JButton JBAceptarConfDispositivos=new JButton("Salvar");
			JBAceptarConfDispositivos.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					if(JCBoxRedConfDispositivos.getSelectedIndex()==0)
					{
					JOptionPane.showMessageDialog(null,"No existe red seleccionada.", "Alerta", JOptionPane.ERROR_MESSAGE);
					}
					else
					{
					try
					{
					RedAlias=JCBoxRedConfDispositivos.getSelectedItem().toString().substring(JCBoxRedConfDispositivos.getSelectedItem().toString().indexOf("(")+1,JCBoxRedConfDispositivos.getSelectedItem().toString().length()-1);
					File FGuardarDispositivos=new File("Redes/"+RedAlias+"/Red.cfg");
					FGuardarDispositivos.delete();
					RandomAccessFile GuardarDispositivos=new RandomAccessFile("Redes/"+RedAlias+"/Red.cfg","rw");
						for(int i=0;i<tableModel.getRowCount();i++)
						{
						GuardarDispositivos.writeBytes(""+tableModel.getValueAt(i,0)+","+tableModel.getValueAt(i,1)+","+tableModel.getValueAt(i,2)+","+ListasConfDispositivos[0].get(i).toString()+","+ListasConfDispositivos[1].get(i).toString()+","+ListasConfDispositivos[2].get(i).toString()+"\r\n");
						}
					GuardarDispositivos.close();
					}
					catch(IOException error)
					{
					}
					}
				}
			});

	final JButton JBAgregarConfDispositivos=new JButton("Agregar");
			JBAgregarConfDispositivos.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
				boolean existe=false;
					for(int i=0;i<tableModel.getRowCount();i++)
					{
						if(tableModel.getValueAt(i,2).equals(JTDirIPConfDispositivos.getText()))
						{
						existe=true;
						}
					}
					if((JCBoxRedConfDispositivos.getSelectedIndex()!=0)&&(existe==false)&&(JTNombreConfDispositivos.getText().length()>0)&&(JTDirIPConfDispositivos.getText().length()>0)&&(JTClave1ConfDispositivos.getText().length()>0)&&(JTClave2ConfDispositivos.getText().length()>0))
					{
					Vector VEnlaces=new Vector();
					VEnlaces.add(JCBoxRedConfDispositivos.getSelectedItem());
					VEnlaces.add(JTNombreConfDispositivos.getText());
					VEnlaces.add(JTDirIPConfDispositivos.getText());
					tableModel.addRow(VEnlaces);
					String Usuario=JTUsuarioConfDispositivos.getText();
						if(JTUsuarioConfDispositivos.getText().equals(""))
						{
						Usuario="%";
						}
					ListasConfDispositivos[0].add(Usuario);
					ListasConfDispositivos[1].add(JTClave1ConfDispositivos.getText());
					ListasConfDispositivos[2].add(JTClave2ConfDispositivos.getText());
					}
				}
			});

	final JButton JBBorrarConfDispositivos=new JButton("Borrar");
			JBBorrarConfDispositivos.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
				JTNombreConfDispositivos.setText("");
				JTDirIPConfDispositivos.setText("");
				JTUsuarioConfDispositivos.setText("");
				JTClave1ConfDispositivos.setText("");
				JTClave2ConfDispositivos.setText("");
				}
			});
	final JButton JBEliminarConfDispositivos=new JButton("Eliminar");
JBEliminarConfDispositivos.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					if(tabla.getSelectedRow()>=0)
					{
					int i=tabla.getSelectedRow();
						if(i<0)
						{
						tabla.setRowSelectionInterval(i-1,i-1);
						}
						else
						{
							try
							{
							tabla.clearSelection();
							}
							catch(ArrayIndexOutOfBoundsException error)
							{
							}
						}
					ListasConfDispositivos[0].remove(i);
					ListasConfDispositivos[1].remove(i);
					ListasConfDispositivos[2].remove(i);
					tableModel.removeRow(i);
					}
				}
			});
	JPBotoneraConfDispositivos.add(JBAceptarConfDispositivos);
	JPBotoneraConfDispositivos.add(JBAgregarConfDispositivos);
	JPBotoneraConfDispositivos.add(JBBorrarConfDispositivos);
	JPBotoneraConfDispositivos.add(JBEliminarConfDispositivos);
	JPOrdenarAgruparyTablaConfDispositivos.add(JPAgruparConfDispositivos);
	JPOrdenarAgruparyTablaConfDispositivos.add(JPtabla);
	JPAgruparTodoConfDispositivos.add(JPOrdenarAgruparyTablaConfDispositivos);
	JPPrincipalConfDispositivos.add("Center",JPAgruparTodoConfDispositivos);
	JPPrincipalConfDispositivos.add("South",JPBotoneraConfDispositivos);
	BorrarDispositivos();



JCBoxRedConfDispositivos.addActionListener(new ActionListener()
	{
		public void actionPerformed(ActionEvent e)
		{
			if(JCBoxRedConfDispositivos.getSelectedIndex()>=0)
			{
			RedAlias=JCBoxRedConfDispositivos.getSelectedItem().toString().substring(JCBoxRedConfDispositivos.getSelectedItem().toString().indexOf("(")+1,JCBoxRedConfDispositivos.getSelectedItem().toString().length()-1);
				if(JCBoxRedConfDispositivos.getSelectedIndex()==0)
				{
				JTNombreConfDispositivos.setEnabled(false);
				JTNombreConfDispositivos.setEnabled(false);
				JTDirIPConfDispositivos.setEnabled(false);
				JTUsuarioConfDispositivos.setEnabled(false);
				JTClave1ConfDispositivos.setEnabled(false);
				JTClave2ConfDispositivos.setEnabled(false);
				}
				else
				{
				JTNombreConfDispositivos.setEnabled(true);
				JTDirIPConfDispositivos.setEnabled(true);
				JTUsuarioConfDispositivos.setEnabled(true);
				JTClave1ConfDispositivos.setEnabled(true);
				JTClave2ConfDispositivos.setEnabled(true);
				}
			BorrarDispositivos();
			}
			if(JCBoxRedConfDispositivos.getSelectedIndex()> 0)
			{
				try
				{

				RandomAccessFile LeerRed=new RandomAccessFile("Redes/"+RedAlias+"/Red.cfg","r");
				String leer;
					while((leer=LeerRed.readLine())!=null)
					{
					Vector VEnlaces=new Vector();
					StringTokenizer tok=new StringTokenizer(leer,",");
					int i=0;
						while(tok.hasMoreTokens())
						{
							if((i==3)||(i==4)||(i==5))
							{
							if(i==3){ListasConfDispositivos[0].add(tok.nextToken());}
							if(i==4){ListasConfDispositivos[1].add(tok.nextToken());}
							if(i==5){ListasConfDispositivos[2].add(tok.nextToken());}
							}
							else
							{
							VEnlaces.add(tok.nextToken());
							}
						i++;
						}
					tableModel.addRow(VEnlaces);
					}
				LeerRed.close();
				}
				catch(IOException ie)
				{
				}
				
			}
		}
	});



	}
	public void BorrarDispositivos()
	{
		while(tabla.getSelectedRow()!= -1)
		{
			try
			{
			tabla.clearSelection();
			}
			catch(ArrayIndexOutOfBoundsException error)
			{
			}
		}
	int x=0;
		for(int i=tableModel.getRowCount();i>x;i--)
		{
		tableModel.removeRow(i-1);
		ListasConfDispositivos[0].remove(i-1);
		ListasConfDispositivos[1].remove(i-1);
		ListasConfDispositivos[2].remove(i-1);
		}
	}
	public void ActualizarRedes()
	{
	JCBoxRedConfDispositivos.removeAllItems();
		JCBoxRedConfDispositivos.addItem("Seleccione la red");
		try
		{
		RandomAccessFile ArchivoRedes=new RandomAccessFile("Redes/Redes.cfg","r");
		String leer;
			while((leer=ArchivoRedes.readLine())!=null)
			{
			JCBoxRedConfDispositivos.addItem(leer);
			}
		ArchivoRedes.close();
		}
		catch(IOException error)
		{
		System.out.println(error.toString());
		}	
	}
}